function Plot_v_of_t(sol_r,spike_time_record,N)
% N,sol_r, spike_time_record
if nargin < 3
    [N,~]=size(sol_r.y);
    N=N/6;
end
global I g0 gc0_I
T_eff = diff(spike_time_record');
T_eff_head = T_eff(:,1);
if (~isempty(T_eff_head(T_eff_head>0)))
    T_eff = T_eff_head(T_eff_head>0);
    T_eff = T_eff(end);
else
    T_eff=0;
end
T     = T_eff;

type_I_id = 1:N/2;
type_II_id = (N/2+1):N;
type_I_id_select = 1:7;
type_II_id_select = N/2+type_I_id_select;

maxV = max(max(sol_r.y(1:N,:)));
minV = min(min(sol_r.y(1:N,:)));
maxT = max(sol_r.x);
if (1==1)
    %% PLOT ALL SEGMENTS TOGETHER
    f_v_of_t=figure(1000);
    title('Voltages and synaptic variables for all neurons ')
    pl_I = plot(sol_r.x,sol_r.y(type_I_id,:));
    set(f_v_of_t,'color','w')
    pallete_neuron = get(pl_I,'color');
    hold on
    for nid = type_I_id
        pl_syn(nid)=plot(sol_r.x,(sol_r.y(2*N+nid,:)-sol_r.y(3*N+nid,:))/(max(sol_r.y(2*N+nid,:)-sol_r.y(3*N+nid,:))),'color',pallete_neuron{nid});
    end
    for sp_id = 1:length(spike_time_record(1,:))
        text(spike_time_record(1,sp_id),max(sol_r.y(1,:)),num2str(sp_id))
    end
    for nid=1:N/2
        pl_II(nid) = plot(sol_r.x,sol_r.y(type_II_id(nid),:),'--','color',pallete_neuron{nid});
    end
    %         pallete = get(pl,'color');
    hold on
    for nid = 1:N/2
        nf=max(sol_r.y(2*N+type_II_id(nid),:)-sol_r.y(3*N+type_II_id(nid),:));
        if nf==0
            nf=1;
        end
        chem_syn=(sol_r.y(2*N+type_II_id(nid),:)-sol_r.y(3*N+type_II_id(nid),:));
        plot(sol_r.x,chem_syn/nf,'--','color',pallete_neuron{nid});
    end
    %% LABEL PLOTS
    legend(pl_I)
    xl=xlabel('Time $t$');
    set(xl,'interpreter','latex')
    yl=ylabel('$v$');
    set(yl,'interpreter','latex')
    ylim([minV,1.05*maxV]);
    xlim([0,maxT]);
    tt=title(['$T=$', num2str(T_eff(1)), '$I_{0}=$' num2str(I(1)) ' $ I_{1}=$' num2str((I(2)-I(1)) ),  ', $g_{g}=$' num2str(g0) ,'  $I_{II}=$' num2str(I(N/2+1)),', $g_{c}$=' num2str(gc0_I)] );
    set(tt,'interpreter','latex','fontsize',15)
    hold off
    hgsave(1000,['v2_syn_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    % show v(0), initial voltage values of all Va neurons
    % text(0.1,2,num2str(y_init(1:N/2)))
end     
if (1==1)
    f_v_subplot=figure(1001);
    set(f_v_subplot,'color','w')
    for nid = type_I_id_select
        subplot(length(type_I_id_select),1,nid),plot(sol_r.x,sol_r.y(nid,:),'color',pallete_neuron{nid});
        ylim([minV,1.05*maxV])
        yl=ylabel(['$v_{I',num2str(nid),'}$']);
        set(yl,'interpreter','latex')
        xlim([0,maxT]);
        ax=gca;
        ax.XAxis.FontSize=20;
        ax.YAxis.FontSize=20;
        ax.YTick=[0 3];
        if (nid<type_I_id_select(end))
            ax.XTickLabel=[];
        end
    end
    xl=xlabel('Time $t$');
    set(xl,'interpreter','latex')
    hgsave(1001,['v2aIall_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    
    f_v_subplot=figure(1002);
    set(f_v_subplot,'color','w')
    for nid = type_II_id_select
        subplot(length(type_II_id_select),1,nid-N/2),plot(sol_r.x,sol_r.y(nid,:),'color',pallete_neuron{nid-N/2});
        ylim([minV,1.05*maxV])
        yl=ylabel(['$v_{II,',num2str(nid-N/2),'}$']);
        set(yl,'interpreter','latex')
        xlim([0,maxT]);
    end
    xl=xlabel('Time $t$');
    set(xl,'interpreter','latex')
    hgsave(1002,['v2aIIall_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
end

%
% figure
% imagesc(sol_r.y(type_I_id,:))
% xlabel('Time')
% ylabel('V2a-I Index')

ntimes=2000;
times=linspace(0,sol_r.x(end),ntimes);
% v2aI=deval(sol_r,times);
for itimes=1:ntimes
    index=find(sol_r.x>=times(itimes),1);
    x_app(itimes)=sol_r.x(index);
    y_app(:,itimes)=sol_r.y(:,index);
end

if (1==1)
    figure(100)
    imagesc([0,sol_r.x(end)],[1,N/2],y_app(type_I_id,:));
    axis ij
    xlabel('Time')
    ylabel('V2a-I Index')
    title('V2a-I');
    hgsave(100,['v2aI_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    export_fig(100,['v2aI_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.pdf']);
end

if (1==2)
    
    figure(101)
    imagesc([0,sol_r.x(end)],[1,N],y_app(1:N,:));
    axis ij
    xlabel('Time')
    ylabel('V')
    colorbar
    title(' V: 1:N');
    hgsave(101,['V_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    export_fig(101,['V_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.pdf']);
    
    figure(102)
    imagesc([0,sol_r.x(end)],[1,N],y_app(N+1:2*N,:));
    axis ij
    xlabel('Time')
    colorbar
    title(' s: N+1:2N');
    hgsave(102,['s_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    figure(103)
    imagesc([0,sol_r.x(end)],[1,N],y_app(2*N+1:3*N,:));
    axis ij
    xlabel('Time')
    title(' syn1: 2N+1:3N');
    colorbar
    hgsave(103,['syn1_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    
    figure(104)
    imagesc([0,sol_r.x(end)],[1,N],y_app(3*N+1:4*N,:));
    axis ij
    xlabel('Time')
    title(' syn2: 3N+1:4N');
    colorbar
    hgsave(104,['syn2_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    
    figure(105)
    imagesc([0,sol_r.x(end)],[1,N],y_app(4*N+1:5*N,:));
    axis ij
    xlabel('Time')
    title(' w: 4N+1:5N');
    colorbar
    hgsave(105,['w_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
    
    figure(106)
    imagesc([0,sol_r.x(end)],[1,N],y_app(5*N+1:6*N,:));
    axis ij
    xlabel('Time')
    title(' r: 5N+1:6N');
    colorbar
    hgsave(106,['r_N',num2str(N),'_T',num2str(T_eff(1)),'_I0',num2str(I(1)),'_I1',num2str((I(2)-I(1)),'%.4f'),'_gg',num2str(g0,'%.2f'),'_III',num2str(I(N/2+1)),'_gc',num2str(gc0_I),'.fig']);
end


end

