%% SET PARAMETERS
    % NETWORK SETUP
    n = 16;                              % Number of segments
    
    epsilon = 1;                        % epsilon   Asymptotic parameter
    
    % SYNAPTIC STRENGTH
    g_g     =   1;                      % g_g: gap junction coupling strength
    g_c     =   0.1;                      % g_c: chemical synaptic conductance from V2a-II to V2a-I
    g_c_II  =   7.15;                      % g_{c,II}: chemical synaptic conductance from V2a-I to V2a-II
    % BIAS CURRENT
    I_I     =   1/(1-exp(-3));        % I_I :Bias current of leading V2a-I neuron
    DeltaI  =   -0.04;                  % Delta I: Difference in bias current between leader and follower V2a-I neurons
    I_II    =   0.9;                      % I_II: Bias current of V2a-II neurons

    cyc_nums = 7;                       % Number of cycles wish to simulate

    
    SimulateModel(n,epsilon,g_g,g_c,g_c_II,I_I,DeltaI,I_II,cyc_nums)
