function scan
% before running scan clear workspace with clear all
rng(0)

%% SET PARAMETERS
% NETWORK SETUP
n = 32;                              % Number of segments

epsilon = 1;                        % epsilon   Asymptotic parameter

% SYNAPTIC STRENGTH
g_g_all     =  [0.2,0.3,0.5,0.7,0.8,0.9];                      % g_g: gap junction coupling strength
g_c     =   0.1;                      % g_c: chemical synaptic conductance from V2a-II to V2a-I
g_c_II  =   0;%7.15;                      % g_{c,II}: chemical synaptic conductance from V2a-I to V2a-II
% BIAS CURRENT
I_I     =   1/(1-exp(-3));        % I_I :Bias current of leading V2a-I neuron
DeltaI_all  = -0.05;%  [-0.02:-0.02:-0.08];                  % Delta I: Difference in bias current between leader and follower V2a-I neurons
I_II    =   1.4;%0.9;                      % I_II: Bias current of V2a-II neurons

cyc_nums = 20;%8;                       % Number of cycles wish to simulate

%rng(2)
for g_g=g_g_all
    for DeltaI=DeltaI_all
        tic
        fprintf('DeltaI=%g g_g=%g \n',DeltaI,g_g);
        srng=rng;
        save(['rng_DeltaI',num2str(DeltaI,'%.4f'),'_g',num2str(g_g,'%.4f'),'.mat'],'srng');
        %load(['rng_DeltaI',num2str(DeltaI,'%.4f'),'_g',num2str(g_g,'%.4f'),'.mat'],'srng');
        %rng(srng)
        SimulateModel(n,epsilon,g_g,g_c,g_c_II,I_I,DeltaI,I_II,cyc_nums)
        toc
    end
end

end

