%% SET PARAMETERS
% NETWORK SETUP
n = 8;                              % Number of segments

epsilon_all = [5,2,1,0.5,0.1];     % List of epsilon   Asymptotic parameter

% SYNAPTIC STRENGTH
g_g     =   1;                      % g_g: gap junction coupling strength
g_c     =   0;                      % g_c: chemical synaptic conductance from V2a-II to V2a-I
g_c_II  =   0;                      % g_{c,II}: chemical synaptic conductance from V2a-I to V2a-II
% BIAS CURRENT
I_I     =   1/(1-exp(-7));        % I_I :Bias current of leading V2a-I neuron
DeltaI  =   -0.01;                  % Delta I: Difference in bias current between leader and follower V2a-I neurons
I_II    =   0;                      % I_II: Bias current of V2a-II neurons

cyc_nums = 10;                       % Number of cycles wish to simulate

phi_log = [];
for eid = epsilon_all
    epsilon = eid;
    [~,~,phi]= SimulateModel_MeasureISPD(n,epsilon,g_g,g_c,g_c_II,I_I,DeltaI,I_II,cyc_nums);
    phi_log = [phi_log phi];
end

figure;
plot(phi_log,DeltaI*ones(1,length(epsilon_all)),'*')
hold on
%%
DeltaI  =   -0.03;                  % Delta I: Difference in bias current between leader and follower V2a-I neurons

phi_log = [];
for eid = epsilon_all
    epsilon = eid;
    [~,~,phi]= SimulateModel_MeasureISPD(n,epsilon,g_g,g_c,g_c_II,I_I,DeltaI,I_II,cyc_nums);
    phi_log = [phi_log phi];
end
hold on
plot(phi_log,DeltaI*ones(1,length(epsilon_all)),'*')
yl=ylabel('$\Delta I$');
set(yl,'interpreter','latex')
xl=xlabel('$\phi$');
set(xl,'interpreter','latex')