%% SET PARAMETERS
% NETWORK SETUP
n = 8;                              % Number of segments

epsilon = 1;     % List of epsilon   Asymptotic parameter

% SYNAPTIC STRENGTH
g_g     =   1;                      % g_g: gap junction coupling strength
g_c     =   0;                      % g_c: chemical synaptic conductance from V2a-II to V2a-I
g_c_II  =   0;                      % g_{c,II}: chemical synaptic conductance from V2a-I to V2a-II
% BIAS CURRENT
Tapprox = [16,12,8,7,6,5,4.5,4];
I_I_all     = 1./(1-exp(-Tapprox));      
% I_{I,0} :Bias current of leading V2a-I neuron 
% for f= 59.3,77.7,112.8,127.2,145.7,170.7,186.7,206.7

DeltaI  =   -0.02;                  % Delta I: Difference in bias current between leader and follower V2a-I neurons
I_II    =   0;                      % I_II: Bias current of V2a-II neurons

cyc_nums = 10;                       % Number of cycles wish to simulate


Delta_I_correct = [0,diff(I_I_all)];



phi_log = [];
for IIid = 1:length(I_I_all)
    I_I = I_I_all(IIid);
    DeltaI= DeltaI-Delta_I_correct(IIid);
    DeltaI_log(IIid)=DeltaI;
    [~,~,phi]= SimulateModel_MeasureISPD(n,epsilon,g_g,g_c,g_c_II,I_I,DeltaI,I_II,cyc_nums);
    phi_log = [phi_log phi];
end
figure;
hold on
plot(phi_log,DeltaI_log,'o')
yl=ylabel('$\Delta I$');
set(yl,'interpreter','latex')
xl=xlabel('$\phi$');
set(xl,'interpreter','latex')