function [order_c,spk_fail,ISPD]=SimulateModel_MeasureISPD(n_,epsilon_,g_g_,g_c_,g_c_II_,I_I_,DeltaI_,I_II_,cyc_nums_,plot_option)
if (nargin<10)
    plot_option = 1;
end
if (nargin < 8)
    %% SET PARAMETERS
    % NETWORK SETUP
    n = 6;                          % Number of segments
    %% Asymptotic parameter
    epsilon = 1;                    % epsilon
    % SYNAPTIC STRENGTH
    g_g     =   2;                  % g_g
    g_c     =   0.1;                % g_c
    g_c_II  =   7.15;               % g_c_II
    % BIAS CURRENT
    I_I     =   1/(1-exp(-3));       % I_I BIAS CURRENT OF LEADER NEURON
    DeltaI  =   0.01;                % Delta I
    I_II    =   0.8;                 % I_II
    cycle_num = 7;

else
    n = n_;                          % Number of segments
    %% Asymptotic parameter
    epsilon = epsilon_;                 % epsilon
    % SYNAPTIC STRENGTH
    g_g     =   g_g_;                   % g_g
    g_c     =   g_c_;                   % g_c
    g_c_II  =   g_c_II_;                % g_c_II
    % BIAS CURRENT
    I_I     =   I_I_;                   % I_I BIAS CURRENT OF LEADER NEURON
    DeltaI  =   DeltaI_;                % Delta I
    I_II    =   I_II_;                  % I_II
    cycle_num = cyc_nums_;

end

%% SET NEURON PARAMETERS
v_T     = 1;
v_A     = 0.2;
xi      = 9.1;
Delta   = 0.5;
Delta_v = 3.3;
a_      = 1;
Tau_w   = 5;
b       = 0.1;
%% SET GLUTAMATERGIC SYNAPTIC PARAMETERS
E_syn   = 10;
sigma_f = 5;        % sigma_f
sigma_r = 5.5;     % sigma_r


%%
global N_set  g0all gc0all gc0_II epsil
global I0_ref I1_fix I2_now I
SetParameters(n,g_g,g_c,g_c_II,I_I,DeltaI,I_II,epsilon)
global N I psi g delta Vm Va V_threshold
global a tau_w del_w tau_v
global r1 r2 s_mat Esyn s0 syn_delay reset_per
global Spk_switch Reset_switch

SetParameterNeuron(v_T,v_A,xi,Delta,Delta_v,a_,Tau_w,b,E_syn,sigma_f,sigma_r)

%% SIMULATION PARAMETERS
% global fail_neuron_num fail_rate
random_init = 1;
%% SET PREDETERMINED "RANDOM" INIT CONDITIONS
% random_init_assign = ['rand_repeat_tab_' num2str(N_set) '.mat']
% random_init_table= 'rand_tab.mat';
%% CONSTRUCT MATRICES FOR g_g(i,j), g_c(i,j) and g_c,II (i,j)
global g0 gc0_I
g0              = epsil*g0all;      % rescale O(epsilon^1) parameters
gc0_I           = epsil*s0*gc0all;% rescale O(epsilon^1) parameters
gc0_II          = 1*gc0_II;               % g_c_II
ax_range_II     = 1;
global g s_mat
[g,s_mat] = constructMatrix_gg_gc(g0,gc0_I,gc0_II,ax_range_II);

%%
% n_tstep = 1;
% g_gap_sample = g0;
% said =1;% PROBABLY NOT NEEDED
%     s_amp = 1;
%% INITIALIZE V(t) for V2a neurons (type I and II)
y_init = zeros(6*N,1);
v_init = zeros(N,1);
if (random_init)
    %% SET Random initial values for v
    v_temp = rand(N,1);
    v_init =v_temp;
else
    % descending order
    v_temp = rand(N,1);
    v_temp = sort(v_temp,'descend');
    v_init =v_temp;
end
y_init(1:N) = v_init;
%% y_init_sample has <1> copies of y_init

if ~exist('n_first')
    n_first = min(4,N/2-1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     B_Integrate_type_I_and_II{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[sol_r,phi_obs,spk_fail,spike_time_record,t_max,v_reset_record,diff_st_rec,conv_t,conv_c,order_t,order_c]=Run_simul_adaptive(y_init,cycle_num);
[seg_nums,cyc_nums]=size(spike_time_record);
if (plot_option)
    Plot_v_of_t(sol_r,spike_time_record)

end
Plot_phi_over_cycles
if exist('phi_segs_now_mod') 
    if (length(phi_segs_now_mod)>4)
    ISPD = mean(phi_segs_now_mod(ceil(length(phi_segs_now_mod)/2):end));
    else
        ISPD=[];
    end
else
    ISPD = [];
end
if ~(plot_option)
    close all
end
end

