function [solution, phi_obs,spk_fail, spike_time_record,t_max,v_reset_record,diff_time_record,convg_time,convg_cycle,order_time,order_cycle] = Run_simul_curr_sorting_check(y_init,spk_num,phi)
global N I psi g delta Vm Va V_threshold Per eta_star T Spk_switch Reset_switch switch_time I_new del_w
global fail_neuron_num fail_rate always_on
if isempty(fail_rate)
    fail_rate=1;
end
N_I = N/2;
convg_thresh =0.000001;%0.002;
if nargin<3
    phi = 0.1;
end
convg_time = [];
convg_cycle =[];
order_time = [];
order_cycle = [];
phi_half= T/2;
order_set = 0;
first_receiver=min(5,N_I-1);

opts = odeset('Events',@Main_ODE_event_delay,'RelTol',1e-10,'AbsTol',1e-10);%'MaxStep',1e-2 rel 1e-5 abstol 1e-5 by default
opts = odeset('Events',@Main_ODE_event_delay,'RelTol',1e-7,'AbsTol',1e-7);%'MaxStep',1e-2 rel 1e-5 abstol 1e-5 by default

last_stop_time = 0;
event_tracker = 1;
spk_tracker = zeros(1,N); % counts the spikes for each neuron
spike_time_record= 0;
diff_time_record=0;
v_reset_record = 0;
last_spike_id = 0;

%% Calculate simulation time needed to complete the assined number of cycles
if I(1)>0
T= log(I(1)/(I(1)-1))+delta(1);
else
    T=10;
end
t_max = T*(spk_num+3);
%%

sol_r.y = y_init;
sol_r.x = 0;
sol_r.ie = [];
sol_r.xe = [];
sol_r.ye = [];

%%
I_toggle=0;
Spk_switch_prev = Spk_switch;
Syn_switch = zeros(N,1);
Syn_switch_prev = Syn_switch;


while last_stop_time(end) < t_max
    if switch_time<last_stop_time(end) & I_toggle==0
        I(2:N) = I_new;
        I_toggle = 1;
    end
    sol = ode15s(@Main_ODE_adaptive,[last_stop_time(end),t_max],y_init,opts);
    last_stop_time(event_tracker) = sol.x(end); % to keep track of time
    
%    last_stop_time(event_tracker)
%    lastwarn
    vmax=max(max(sol.y));
    if (vmax>50)
        t_max=-1;
    end
    spiked_nid = sol.ie;
    
    spk_begin = sol.ie(sol.ie<N+1);
    spk_end   = sol.ie(((sol.ie>N).*(sol.ie<2*N+1))>0)-N; % Index of neuron that just finished spiking
    
    %     syn_begin = sol.ie(((sol.ie>2*N).*(sol.ie<3*N+1))>0)-2*N;
    % turn off delay
    if (2==1)
        syn_begin = sol.ie(((sol.ie>2*N).*(sol.ie<3*N+1))>0)-2*N;
    else
        syn_begin=spk_begin;
    end
    
    reset_begin = spk_end;
    reset_end = sol.ie(((sol.ie>3*N).*(sol.ie<4*N+1))>0)-3*N;
    
    Spk_switch(spk_begin) = 1; % turn on spike current A
    Spk_switch(spk_end) = 0;
    %     Syn_switch(spk_end) = 0;
    %     Syn_switch(syn_begin)= 1;
    
    Reset_switch(reset_begin) = 1; % turn on spike current A
    Reset_switch(reset_end) = 0;
    
    
    if always_on
%         Spk_switch = ones(N,1);
        Reset_switch=ones(N,1);
    end
    
    
    last_spike_id = length(sol.ie);
    sol_reset = sol.y(:,end);
    
    
    sol_reset(spk_end) = sol_reset(spk_end)- (1+Vm(spk_end)); % reset voltage
    
    
    sol_reset(spk_end+N) = 0;  % reset spike clock
    
    sol_reset(reset_end+5*N)=0;
    
    sol_reset(spk_end+4*N) = sol_reset(spk_end+4*N)+del_w(spk_end);
    
    %     [syn_on,~] = find(Syn_switch-Syn_switch_prev>0);
    %         [syn_on,~] = find(Spk_switch-Spk_switch_prev>0);
    
    Spk_switch_prev = Spk_switch;
    Syn_switch_prev = Syn_switch;
    
    if ~isempty('fail_neuron_num')
            fail_now = rand(1,length(fail_neuron_num))<fail_rate;
            fail_now = fail_neuron_num(fail_now);
            fail_now = fail_now(ismember(fail_now,syn_begin));
            if ~isempty(fail_now)
                sol_reset((2*N+fail_now)) = sol_reset(2*N+fail_now)-1;
                sol_reset(3*N+fail_now) = sol_reset(3*N+fail_now)-1;
            end
    end
    
    sol_reset(2*N+syn_begin) = sol_reset(2*N+syn_begin)+1;
    sol_reset(3*N+syn_begin) = sol_reset(3*N+syn_begin)+1;
    %     sol_reset((2*N+syn_begin)) = 1;
    %     sol_reset(3*N+syn_begin) = 1;
    %
    %% Store event number and spike times for each neurons.
    event_tracker = event_tracker + 1;
    if ~isempty(spk_end)
        spk_tracker(spk_end) = spk_tracker(spk_end)+1;
        spike_time_record(spk_end,spk_tracker(spk_end)) = sol.xe(end);
%         spike_time_record(1:N_I,:)
        % check if sorting is complete when the last segments fires by:
        %   - check if ISPD<0.5 for all segments for the current and
        %   previous spike.
        % if ISPD is <0.5 for the current and the previous current, we
        % conclude that the sorting was achieved in t he PREVIOUS spiking
        if (spk_end==N_I) && ~(order_set)
            prev_spk_id=[];
            sorting_check = 1; 
            curr_spk_time = sol.xe(end);
            prev_spk_id = find(spike_time_record(spk_end,:)<curr_spk_time,1,'last');
            if ~isempty(prev_spk_id)
                prev_spk_time = spike_time_record(spk_end,prev_spk_id);
            else
                prev_spk_time = 0;
            end
            T_curr_seg = curr_spk_time-prev_spk_time;

            for nid = N_I:-1:2
                prev_seg_spk_id=find((spike_time_record(nid-1,:)>prev_spk_time).*(spike_time_record(nid-1,:)<curr_spk_time)>0,1,'first');
                if ~isempty(prev_seg_spk_id)
                    prev_seg_spk_time = spike_time_record(nid-1,prev_seg_spk_id);
                else
                    sorting_check= 0;
                    break
                end

                phi_curr_seg = mod((curr_spk_time-prev_seg_spk_time)/T_curr_seg,1);
                if (phi_curr_seg>1/2) && (prev_spk_time>0)
                    sorting_check = 0;
                    break
                end
                curr_spk_time = prev_seg_spk_time;
                prev_valid_spk_id = find(spike_time_record(nid-1,:)>0,1,'last');
                if isempty(prev_valid_spk_id)
                    prev_valid_spk_id=0;
                end
                prev_spk_id = find(spike_time_record(nid-1,1:prev_valid_spk_id)<curr_spk_time,1,'last');
                if ~isempty(prev_spk_id)
               
                    prev_spk_time = spike_time_record(nid-1,prev_spk_id);
                else
                    prev_spk_id = 0;
                    prev_spk_time = 0;
                end
                
                T_curr_seg = curr_spk_time-prev_spk_time;


            end

            if (sorting_check>0)
                order_set = 1;
                if isempty(prev_spk_id)
                    order_cycle=1;
                else
                    order_cycle = prev_spk_id+1;
                end
            end
            % check if the previous cycle was also sorted. 
           if isempty(prev_spk_id)
               prev_spk_id=0;
           end
            if (sorting_check>0) && (prev_spk_id>0)
                prev_cyc_sorting_check = 1;
                for nid = 2:N_I
                    next_seg_spk_id = find((spike_time_record(nid,:)>prev_spk_time),1,'first');
                    if ~isempty(next_seg_spk_id)
                        next_seg_spk_time = spike_time_record(nid,next_seg_spk_id);
                    else
                        prev_cyc_sorting_check = 0;
                        break
                    end
                    phi_curr_seg = mod((next_seg_spk_time-prev_spk_time)/T_curr_seg,1);
                    if phi_curr_seg>1/2
                        prev_cyc_sorting_check = 0;
                        break
                    end
                    prev_spk_time=next_seg_spk_time;

                end
                if (prev_cyc_sorting_check)
                    order_cycle=order_cycle-1;
                end  
            end            

        end

    end
    
    if (order_set)
        t_max = last_stop_time(end);
    end

    %% Set initial values for next integration step
    
    y_init = sol_reset;
    sol_r.y = [sol_r.y, sol.y];
    sol_r.x = [sol_r.x,sol.x];

    sol_r.ie = [sol.ie];
    sol_r.xe = [sol.xe];
    sol_r.ye = [sol.ye];
    
    sol_r.solver=sol.solver;
    sol_r.stats=sol.stats;
    sol_r.idata=sol.idata;
    
end

[sn,nspk]=size(spike_time_record);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
if sn>N_I
nspk = max(sum(spike_time_record(1:N_I,:)>0,2)); 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


sn = min(sn,N_I);


if sn>1
    ls_max=nspk;
    phi_obs=zeros(N_I,nspk);
    
    for nid = 1:sn-1
        s_driver = spike_time_record(nid,:);
        s_driver = s_driver(s_driver>0);
        T_driver = diff(s_driver);
        s_receiver = spike_time_record(nid+1,:);
        s_receiver = s_receiver(s_receiver>0);
        T_receiver = diff(s_receiver);
        
        if abs(length(s_receiver)-length(s_driver))>min(length(s_driver)*.2,3)
            spk_fail=1;
        else
            spk_fail=0;
        end
        ls=min(length(s_driver),length(s_receiver));
        if (ls>1)
            phi_obs(nid,1:ls) = ((s_receiver(1:ls)-s_driver(1:ls))); %./T_driver(1:ls);
        else
            phi_obs =Inf;
            break
        end
        
    end
    
else
    phi_obs =Inf;
    spk_fail = 1;
end
solution = sol_r;

end

