function [dx] = Main_ODE_adaptive(t,x)
global N I psi g delta Vm Va Spk_switch Reset_switch r1 r2 s_mat Esyn a tau_w tau_v always_on I_on
global I0_gas T_gas 
%%%%
if isempty(I_on)
    I_on=0;
end

if t>=I_on
    I_switch=1;
else
    I_switch=0;
end
%%
v = x(1:N);
s = x(N+1:2*N);
syn1 = x((2*N+1):3*N);
syn2 = x((3*N+1):4*N);
w = x((4*N+1):5*N);
r = x((5*N+1):6*N);
ds1 = -r1.*syn1;
ds2 = -r2.*syn2;

glut_curr = (s_mat*(syn1-syn2)).*(Esyn-v);

g_switch = Spk_switch+Reset_switch-Spk_switch.*Reset_switch;

g_on = diag(g_switch);
Na_curr = Spk_switch.*Va.*exp(psi.*Spk_switch.*s);
if always_on
gj_curr = sum(g.* (repmat(v,1,N)-repmat(v',N,1)),2); %(post-pre)
else
gj_curr = sum((g*g_on).* (repmat(v,1,N)-repmat(v',N,1)),2); %(post-pre)
end

if ~isempty(I0_gas)
    if  t>T_gas
        if t<T_gas+0.01
            I_adjusted=I+I0_gas;
        end
        dv = (I_switch*(I+I0_gas)-v -gj_curr +Na_curr +glut_curr  -w)./tau_v;
        
    else
        dv = (I_switch*I-v -gj_curr +Na_curr +glut_curr  -w)./tau_v;
    end
else
    dv = (I_switch*I-v -gj_curr +Na_curr +glut_curr  -w)./tau_v;
end
%%%
ds = Spk_switch;
dw = (a.*v -w)./tau_w;

dr = Reset_switch;

dx = [dv;ds;ds1;ds2;dw;dr];

end

