function  SetParameterNeuron(v_T,v_A,xi,Delta,Delta_v,a_,Tau_w,b,E_syn,sigma_f,sigma_r)
%% SET NEURON PARAMETERS
global N_set N  psi  delta Vm Va V_threshold
N = N_set*2;


V_threshold_default =   v_T;        % v_T
Va_default          =   v_A;        % v_A
psi_default         =   xi;         % xi
delta_default       =   Delta;      % Delta (spike width)
Vm_default      =   Delta_v -1;


%% ADAPTATIVE VARIABLE PARAMETERS
global a tau_w del_w tau_v

a     = a_*ones(N,1);           % a adaptation current
tau_w = Tau_w*ones(N,1);        % tau_w Time scale of adaptation current
del_w = b*ones(N,1);            % b reset of adaptation current

%% SET GLUTAMATERGIC SYNAPTIC PARAMETERS
global r1 r2 s_mat Esyn s0 syn_delay reset_per
Esyn        =   E_syn;          % Reversal potential of the chemcial synapse
r1(1:N,1)   =   sigma_f;      % falling exponential rate in chemical synapse
r2(1:N,1)   =   sigma_r;        % rising exponential rate in chemical synapse
s0          =   sigma_f*sigma_r/(sigma_r-sigma_f); % normalization factor to make AUC of syn. conductance =1
s_mat       =   zeros(N,N);
syn_delay   =   0.001*ones(N,1);

%% ASSIGN PARAMETERS TO NEURONS IN EACH SEGMENT

Vm = Vm_default*ones(N,1);
psi = psi_default*ones(N,1); %xi
delta = delta_default*ones(N,1);
Va = Va_default*ones(N,1);
V_threshold = V_threshold_default*ones(N,1);

% type I, set adaptive varialbe =0
a(1:N/2) = 0;
del_w(1:N/2)=0;
tau_v= [ones(N/2,1);ones(N/2,1)];
% Active period of gap junction current is set as equal to the spike width
reset_per   =   delta;

global Spk_switch Reset_switch
Spk_switch=zeros(N,1);
Reset_switch = zeros(N,1); 


end

